
#include <iostream>
#include <numeric>
#include <vector>
#include <cmath>
#include <climits>
#include <limits>

#include "tbb/parallel_sort.h"
#include "tbb/task_scheduler_init.h"
#include "tbb/tick_count.h"

size_t IdealGrainSize = 10000;
typedef int val_t ;

/*Function to verify if the table has been well sorted*/
template<class T>
bool is_sorted(T output, int sz)
{
     bool is_sorted = true;
     for(int i=1; i < sz; i++) {
         if(output[i-1] > output[i]) {
             std::cout << "output[" << i-1 << "]=" << output[i-1] << " is not less than  ";
             std::cout << "output[" << i << "]=" << output[i] << ", " << std::endl;
             std::cout << "Then the table is not sorted well" << std::endl;
             is_sorted = false;
           break;
        }
     }
  return is_sorted;
}


int main( int argc, char* argv[] ) {

   size_t size = (argc > 1)?atoi(argv[1]):100000000;
   int nthread = (argc > 2)?atoi(argv[2]):1;  

   std::vector<val_t> in_data(size);

   std::cout << "size =" << size << std::endl;

   //initialization of input data
   srand48(0);
   for(size_t i =0; i < size; i++) in_data[i] = lrand48(); //drand48() ; // initial value : put what you want

   std::cout << "***********Start of computation**********" << std::endl;
   std::cout << "The computation size is: " << size << std::endl;

  //initialization of the number of threads
  tbb::task_scheduler_init init(nthread);
 
  tbb::tick_count t0, t1;
  std::cout << "-----------------------------------" << std::endl;
  t0 = tbb::tick_count::now();
     tbb::parallel_sort(in_data.begin(), in_data.end());
  t1 = tbb::tick_count::now();
  printf (": time = %.6f s\n", (t1-t0).seconds());
  std::cout << "-----------------------------------" << std::endl;

   if(is_sorted(in_data, size))
         std::cout << ":The table has been well sorted.........." << std::endl;

 return 0;
}

