
#include <iostream>
#include <numa.h>

#include "tbb/task_scheduler_init.h"
#include "tbb/tick_count.h"

#include "find_if.h"



typedef double val_t ;


int main(int argc, char ** argv) {
      
	    
       int size = 100000000;
       int v , help, s;
       int c = 100 ;//facteur par defaut
       val_t value= 10;
       int nthread= 1;      
 
       char * specifiers [] = { (char*)"-n", (char*)"-c", (char*)"-m", (char*)"-value", (char*)"-np", (char*)"-s", (char*)"-v", (char*)"-h" ,0};
       int opt_types[] = {INTARG, INTARG, INTARG, DOUBLEARG, INTARG, BOOLARG, BOOLARG, 0};
       get_options(argc, argv, specifiers, opt_types, &size, &c, &macroloop_initsize, &value, &nthread, &s, &v, &help, 0);


       val_t *data = (val_t*) numa_alloc_interleaved(size*sizeof(val_t));
       std::cout << "size =" << size << std::endl;
       for(int i =0; i < size; i++) data[i] = i /*0*/;
 
       if ((int)value < size) data[int(value)] = value+1;

       tbb::task_scheduler_init init(nthread);

       tbb::tick_count t0, t1;
       std::cout << "***********Start of computation**********" << std::endl;
       val_t *res;
       t0 = tbb::tick_count::now(); 
       if(!s) res = adapt_find_if(data, data+size, value, c) ;
       else res =  std::find_if(data, data+size, my_fct<val_t>(value)); 
       t1 = tbb::tick_count::now();
       int pos = res-data;
       std::cout << "-----------------------------------" << std::endl;
       printf (": time = %.6f s\n", (t1-t0).seconds());
       std::cout << ": pos_found = " << pos << std::endl; 
       std::cout << std::endl;
       std::cout << "-----------------------------------" << std::endl;
 
       if(v) { 
       std::cout << "-------------------Debut verification---------------" << std::endl;
    
         val_t *tmp = std::find_if(data, data+size, my_fct<val_t>(value)); //STL
         if(pos == (tmp-data) ) std::cout << "La verification est correcte" << std::endl;
         else std::cout << "La verification n'est pas correcte" << std::endl;
         std::cout << "-------------------Fin verification-----------" << std::endl;
       }
 
       numa_free(data, size*sizeof(val_t));    
  return 0;
};

