#ifndef _ATHA_Prod_iter_H_
#define _ATHA_Prod_iter_H_

#include <numeric>
#include "../tbb_adapt.h"
#include "../util/getoptions.h"

unsigned int macroloop_initsize = 300 ; //defaul value

class MyNextJump : public adapt::NextJump {

     int _beg;
     int _end;
   public :
     MyNextJump(int beg=0, int end=0): NextJump(), _beg(beg), _end(end) { }
     void init(int beg, int end) { _beg = beg; _end = end; }
     int get_end() const { return _end;}
     void set_end(int end){ _end = end;}
     int  get_beg() const { return _beg;}
     void set_beg(int beg) {  _beg = beg;}
     bool is_empty() const { return _end <= _beg; }
    // void init_work() const { cout << "MyNextjump" << endl; }
};



template <class T>
struct my_fct {
    T _val;
    my_fct(T val):_val(val) { };
    T operator()(T a){
         return  (_val < a);
    }
};


 
template<class T>
class FindIfWork : public adapt::WorkAdapt
{
    T* _first;
    T* _last;
    int _pos_found;
    T _value;
    int _beg;
    int _end;
    const int _init_beg;
    const int _init_end;
    int _seqgrain;
    int _pargrain;
    int _c;
    int _beg_local;
    int _end_local;
    int _work_do_size;
    T _main_res;
    T _thieft_res;
    int _thieft_pos_found;
    public:

     FindIfWork(T* first, T* last, T value, int beg, int c =1, int pargrain=2): 
       WorkAdapt(), _first(first),  _last(last), _value(value), _pos_found(last-first),
         _beg(beg), _init_beg(beg), _init_end(last - first), _pargrain(pargrain), _c(c)
    {
            _end = _init_end;
           if(c <=0) _seqgrain = 1;
           else _seqgrain = _c * adapt::log_2(_end);
           _thieft_pos_found = -1;
    }


    bool extract_nextseq()
    {
        
        if( _beg < _end ) {
            _beg_local = _beg; _beg +=_seqgrain;
            if( _beg > _end)  _beg = _end;
            _end_local = _beg;
           return true;
         } 
       return false;

    }


    bool extract_par( WorkAdapt*& sw)
    {
           if((_end - _beg) > _pargrain) {
             int i, j;
             int mid = _end - ((_end - _beg)/2);

             
             i = mid;
             j = _end;
             _end = mid;
             //cout << "work : (i, j)=" << "("<< _beg << ", " << _end << ")" << endl;
            // cout << "stolen work : (i, j)=" << "("<< i << ", " << j << ")" << endl;
             sw = new  FindIfWork<T>(_first, _first+j, _value, i, _c);
            return true;
           }
           else {
            sw = new  FindIfWork<T>(_first, _first, _value, 0, 0);
           return false;
          }
    }

     bool  extract_next_macrostep()
     {
          static unsigned int alpha = macroloop_initsize ;
          bool extractmacro = ((_pos_found == _init_end) && (_beg  < _init_end));
          if(extractmacro){

            unsigned int completed_size = _beg - _init_beg ;
            int lg_sz = adapt::log_2(adapt::log_2( completed_size + 4 ) ) ;
            int size_macrostep= alpha*completed_size / lg_sz ;
            if (size_macrostep < macroloop_initsize)
                size_macrostep = macroloop_initsize ;
            _end = _beg + size_macrostep ;

            if(_end > _init_end) _end = _init_end;
             std::cout << "Macrostep:  _beg = " << _beg << ", _end=" << _end << std::endl;
          }
        return extractmacro;
      }


    void join(const WorkAdapt* jw)
    {
        const  FindIfWork<T> * src = dynamic_cast< const  FindIfWork<T>*> ( jw ); 
    
          int thieft_pos_found = src->get_pos_found();
          int thieft_end = src->get_end();
            //std::cout << "victim_pos =" << _pos_found << std::endl;
            //std::cout << "thief_pos_found =" << thieft_pos_found << std::endl;
          if(thieft_pos_found < thieft_end) _thieft_pos_found = thieft_pos_found;
         
    }

    void  localcompute()
    { 
       //Util::Thread::sleep(1, 1000);
       T* tmp = std::find_if(_first + _beg_local, _first + _end_local, my_fct<T>(_value)) ;

       if(tmp <  (_first + _end_local)) {
            _pos_found = tmp-_first;
            _beg = _end; //on s'arrete de continuer
       }      
    }

    inline bool  MustJump() const { return true; }

    T* get_result() const
    {
        return (_first+_pos_found) ;
    }

    int get_pos_found() const
    {
        return _pos_found;
    }

    int get_end() const 
    {
      return _end;
    }

    void setjump(adapt::NextJump*& j) {
        
          int end = _end;
          _end = _beg;
          j = new MyNextJump(_beg, end);   
                
   }

   void jump(const adapt::NextJump* j) {
        
        const  MyNextJump * nextj = dynamic_cast< const  MyNextJump*> ( j );
        
        if((_pos_found==_init_end) && (_thieft_pos_found!=-1)) {
            std::cout << "trouve chez mon voleur...." << std::endl;
            _pos_found =  _thieft_pos_found;
            _beg = _end = nextj->get_end(); // on vide le travail restant
        }
        
        if(_pos_found == _init_end) {
           _beg = nextj->get_beg();
           _end = nextj->get_end();
        }
        else {
            _beg = _end = nextj->get_end();
        }

       /*if(_beg < _end) {
          cout << "Jump Intervall to complete :[" << _beg << " " << _end << "[" << endl;
       }*/
   }

};

template <class T>
T* adapt_find_if(T* first, T* last, T value,
      int seqgrain=10, int pargrain=2) 
{
     FindIfWork<T>* work = new  FindIfWork<T>(first, last, value, 0, seqgrain);
     std::cout << "begin of run" << std::endl; 
     adapt::run_adapt(work);
    T* res = work->get_result();
    return res ; 
}

#endif
