#ifndef _ATHA_Prod_iter_H_
#define _ATHA_Prod_iter_H_

#include <numeric>
#include "../tbb_adapt.h"

class MyNextJump : public adapt::NextJump {

     int _beg;
     int _end;
     int _beg2;
     int _end2;
     


   public :
     MyNextJump(int beg=0, int end=0, int beg2=0, int end2=0): NextJump(), _beg(beg), _end(end), 
                                                              _beg2(beg2), _end2(end2) { }
     void init(int beg, int end, int beg2, int end2) { _beg = beg; _end = end; _beg2 = beg2; _end2 = end2; }
     int get_end() const { return _end;}
     void set_end(int end){ _end = end;}
     int  get_beg() const { return _beg;}
     void set_beg(int beg) {  _beg = beg;}

     int get_end2() const { return _end2;}
     void set_end2(int end2){ _end2 = end2;}
     int  get_beg2() const { return _beg2;}
     void set_beg2(int beg2) {  _beg2 = beg2;}

     bool is_empty() const { return (_end <= _beg) && (_end2 <= _beg2); }
    // void init_work() const { cout << "MyNextjump" << endl; }
};

template <typename T, typename cmp=std::less<T> >
struct less_than
{
   bool operator()(T first, T second) {
     return cmp()(first, second);
   }
};


template<class T, class Compare >
class MergeWork : public adapt::WorkAdapt
{
     T* _first;
     T* _last;
     T* _first2;
     T* _last2;
     T* _res;
     int _beg;
     int _beg2;
     Compare _cmp;
     const int _init_beg;
     const int _init_beg2;
     const int _init_end;
     int _end;
     int _end2;
     int _c;
     int _pargrain;
     int _sz;
     int _seqgrain;
   
    int _beg_local;
    int _end_local;
    int _beg_local2;
    int _end_local2;
    bool _signal_stop;
    bool _Iam_stopped;
    bool _thieft_stopped;
     Util::Mutex _my_mutex;
    bool _wait;
    int _thieft_beg1;
    int _thieft_beg2;

    public:

     MergeWork(T* first, T* last, T* first2, T* last2, T*res, int beg, int beg2, Compare cmp, int c =1, 
              int pargrain=2, int sz=0): WorkAdapt(), _first(first),  _last(last), _first2(first2),
              _last2(last2), _res(res), _beg(beg), _beg2(beg2), _cmp(cmp), _init_beg(_beg), _init_beg2(_beg2), 
             _init_end(last - first), _pargrain(pargrain), _c(c), _sz(sz)
    {
            _end = _init_end;
            _end2 = last2-first2;
           if(c <=0) _seqgrain = 1;
           else _seqgrain = _c*adapt::log_2(_end);

           _beg_local = _beg;
           _end_local = _beg;

           _beg_local2 = beg2;
           _end_local2 = _beg2;
           _signal_stop = false;
           _Iam_stopped = false;
           _thieft_stopped = false;
           _my_mutex.initialize();
           _wait = false;
          //if(_sz)  cout << "in constructor sz =" << _sz << endl;
    }


    bool extract_nextseq()
    {
            _wait = true;
        
           bool test_end1 = (_beg < _end) && (_beg_local >= _end_local);
           bool test_end2 = (_beg2 < _end2) && (_beg_local2 >= _end_local2);
           bool test3 = (_beg < _end) && (_beg_local < _end_local);
           bool test4 = (_beg2 < _end2) && (_beg_local2 < _end_local2);


          if(_signal_stop) { _Iam_stopped=true; }

          if( test_end1 && test_end2 )  {
            _beg_local = _beg; _beg +=_seqgrain;
            if( _beg > _end)  _beg = _end;
            _end_local = _beg;
            
            //std::cout << "extract1" << "(" << _beg_local << ", " << _end_local << "), sz=" << _sz << std::endl;

            _beg_local2 = _beg2; _beg2 +=_seqgrain;
            if( _beg2 > _end2)  _beg2 = _end2;
            _end_local2 = _beg2;
           
             return true;
           } 
           else if(test_end1) {
            _beg_local = _beg; _beg +=_seqgrain;
            if( _beg > _end)  _beg = _end;
            _end_local = _beg;
             return true;
           }
           else if(test_end2) {
            _beg_local2 = _beg2; _beg2 +=_seqgrain;
            if( _beg2 > _end2)  _beg2 = _end2;
            _end_local2 = _beg2;
             return true;
           }
           else if((_beg >= _end) && (_beg_local2 < _end_local2) && !_signal_stop ) {
             _beg2 = _end2;
            _end_local2 = _beg2;
             //std::cout << "extract4" << "(" << _beg_local2 << ", " << _end_local2 << ")" << std::endl;
            return true;
           }
           else if((_beg2 >= _end2) && (_beg_local < _end_local) && !_signal_stop ) {
            _beg = _end;
            _end_local = _beg;
             //std::cout << "extract5" << "(" << _beg_local << ", " << _end_local << ")" << std::endl;
            return true;
           }
           else if((test3 || test4) && !_signal_stop) {
                   std::cout << "extract6" << "(" << _beg_local << ", " << _end_local << ")" << std::endl;
                     return true;
           }
           else { _wait=false; return false;}
    }


    bool extract_par(WorkAdapt*& sw)
    {
        int size1 = (_end - _beg);
        int size2 =  (_end2-_beg2);
        if( size1 > _pargrain || size2 > _pargrain) {
          
          if(size1 > size2) {
            int i1, j1, i2, j2;
            int mid = _end - ((_end - _beg)/2);
             //cout << "in extractpar sz=" << _sz << endl;    
            T*  split2 = std::lower_bound(_first2+_beg2, _first2+_end2, *(_first+mid));
            ptrdiff_t ptr_diff = (split2 - _first2);
            i2 = ptr_diff;
            //cout << "_beg2=" << _beg2 << ", i2=" << i2 << endl;
            if(i2<=_beg2) {
                    //cout << "*(_first+mid)=" << *(_first+mid) << endl;
                   //cout << "before i2=" << i2 << ", sz=" << (_end + _end2) << endl;
                   // cout << "_beg2=" << _beg2 << ", _end2=" << _end2 << endl;
                   bool tmp;
                  _my_mutex.lock();
                     tmp = _wait;
                   _my_mutex.unlock();
                 static int cpt=0;
                 while(tmp) {
                   _my_mutex.lock();
                     tmp = _wait;
                   _my_mutex.unlock();
                   sched_yield(); 
                   //cpt++; if(cpt < 10) cout <<"waiting in part 1..." << endl;
                 }
                 _wait = false;
                 T*  split2 = std::lower_bound(_first2+_beg_local2, _first2+_beg2, *(_first+mid));
                 ptr_diff = (split2 - _first2);
                 i2 = ptr_diff;
                 //cout << "after i2=" << i2 << ", sz=" << (_end + i2) <<  endl;
                 _beg2 = _beg_local2;
                 _end_local2=_beg_local2;
            }
            i1 = mid;
            j1 = _end;
            _end = mid;
            j2 = _end2;
            _end2 = i2;

          #ifdef PRINT
            cout << "1:work : (i1, j1)=" << "("<< _beg << ", " << _end << ")" << std::endl;
            cout << "1:stolen work : (i1, j1)=" << "("<< i1 << ", " << j1 << ")" << std::endl;
            cout << "1:work : (i2, j2)=" << "("<< _beg2 << ", " << _end2 << ")" << std::endl;
            cout << "1:stolen work : (i2, j2)=" << "("<< i2 << ", " << j2 << ")" << std::endl;
          #endif
            //cout << "_init_beg=" << _init_beg << ", _init_beg2=" << _init_beg2 << endl;
            //int sz = (_end-_init_beg)+(_end2-_init_beg2);
            int sz = (_end + _end2);
            //cout << "sz = " << sz << endl;
            sw = new MergeWork<T, Compare>(_first, _first+j1, _first2, _first2+j2,
                                  _res, i1, i2, _cmp, _c, _pargrain, sz);
          }
          else {
                int i1, j1, i2, j2;
                int mid = _end2 - ((_end2 - _beg2)/2);
                T*  split2 = std::upper_bound(_first+_beg, _first+_end, *(_first2+mid));
                ptrdiff_t ptr_diff = (split2 - _first);
                i1 = ptr_diff;
                //cout << "_beg=" << _beg << ", i1=" << i1 << endl;
                if(i1<=_beg) {
                   bool tmp;
                  _my_mutex.lock();
                     tmp = _wait;
                   _my_mutex.unlock();
                 //cout << "before i1=" << i2 << ", sz=" << (_end + _end2) << endl;
                 static int cpt = 0;
                 while(tmp) {
                   _my_mutex.lock();
                     tmp = _wait;
                   _my_mutex.unlock();
                   sched_yield();
                   //cpt++; if(cpt < 10) cout <<"waiting in part 2..." << endl;
                 }
                 _wait = false;
                 T*  split2 = std::upper_bound(_first+_beg_local, _first+_beg, *(_first2+mid));
                 ptr_diff = (split2 - _first);
                 i1 = ptr_diff;
                 _beg = _beg_local;
                 _end_local=_beg_local;
            }
            i2 = mid;
            j2 = _end2;
            _end2 = mid;
            j1 = _end;
            _end = i1;
            #ifdef PRINT
            cout << "2:work : (i1, j1)=" << "("<< _beg << ", " << _end << ")" << std::endl;
            cout << "2:stolen work : (i1, j1)=" << "("<< i1 << ", " << j1 << ")" << std::endl;
            cout << "2:work : (i2, j2)=" << "("<< _beg2 << ", " << _end2 << ")" << std::endl;
            cout << "2:stolen work : (i2, j2)=" << "("<< i2 << ", " << j2 << ")" << std::endl;
            #endif
            int sz = (_end + _end2);
            sw = new MergeWork<T, Compare>(_first, _first+j1, _first2, _first2+j2,
                                  _res, i1, i2, _cmp, _c, _pargrain, sz);
           }

         return true;
        }
        else {
            sw = new MergeWork<T, Compare>(_first, _first, _first2, _first2, 0, 0, 0, _cmp);
         return false;
        }
    }

    /*void join(const WorkAdapt* jw)
    {
    }*/

    void  localcompute()
    { 
         //Util::Thread::sleep(1, 1000); 
         //Util::Thread::sleep(1000, 1);
         //static int incr=0;
        // incr++;
        //std::cout << incr << ":local work : (b1, e1) =" << "(" << _beg_local << ", " << _end_local << ")" << std::endl;
        //std::cout << incr <<  "local work : (b2, e2) =" << "(" << _beg_local2 << ", " << _end_local2 << ")" << std::endl;
         T* first1 = _first+_beg_local;
         T* last1 = _first+_end_local;
         T* first2 = _first2+_beg_local2;
         T* last2 = _first2+_end_local2;
         T* res = _res + _sz;
         if(first1 >= last1) {
            int size2= (_end_local2-_beg_local2);
            //memcpy(res, first2, sizeof(T)*(size2));
            std::copy(first2, last2, res);
            _sz += (size2);
            _beg_local2 =  _end_local2 ;
          }
          else if(first2 >= last2) {
            int size1= (_end_local-_beg_local);
            //memcpy(res, first1, sizeof(T)*(size1));
            std::copy(first1, last1, res);
            _sz += size1;
           _beg_local =  _end_local ;
         }
         else {

             while((first1!=last1) && (first2!=last2)) {
                 if(_cmp(*first2, *first1))  *res++ = *first2++;
                 else *res++ = *first1++;
             }
            
             _beg_local = (first1-_first);
             _beg_local2 = (first2-_first2);
             _sz = (_beg_local + _beg_local2);
        }

   
         _my_mutex.lock();
            _wait = false;
         _my_mutex.unlock();
     }


    void join(const WorkAdapt* jw)
    {
        const  MergeWork * src = dynamic_cast< const  MergeWork*> ( jw );

         int thieft_sz = src->get_sz();
         _thieft_beg1 = src->get_beg();
         _thieft_beg2 = src->get_beg2();
         _thieft_stopped = src->get_stop();
         //std::cout << "victim_sz =" << _sz << std::endl;
         //std::cout << "thieft_sz =" << thieft_sz << std::endl;
         _sz =  thieft_sz;
    }



    int get_sz() const { return _sz; }
    bool get_stop() const { return _Iam_stopped; }
  
    int get_beg() const { return _beg_local;} 
    int get_beg2() const { return _beg_local2;}

   bool  MainJump() const { return false; }
   // inline bool  MustJump() const { return true; }

    void setjump(adapt::NextJump*& j) {
          int beg, beg2;        
         
         //cout << "set jump : beg1=" <<  _beg << ", _end1=" << _end <<  endl;  
           beg = _beg;
          _beg = _end;
          
        //cout << "set jump : beg2=" <<  _beg2 << ", _end2=" << _end2 <<  endl;
        //cout << "set jump : _beg_local2=" <<  _beg_local2 << ", _end_local2=" << _end_local2 <<  endl;
           beg2 = _beg2;
          _beg2 = _end2;
         
           j = new MyNextJump(beg, _end, beg2, _end2);  
           _signal_stop = true; 
                
   }

   void jump(const adapt::NextJump* j) {
        
        const  MyNextJump * nextj = dynamic_cast< const  MyNextJump*> ( j );
        
       if(!_thieft_stopped) {
              _beg = nextj->get_beg();
              _beg2 = nextj->get_beg2();
              _end = nextj->get_end();
              _end2 = nextj->get_end2();
              //cout << "not prempt : beg1=" <<  _beg << ", _end=" << _end <<  endl;
              //cout << "not preempt : beg2=" <<  _beg2 << ", _end2=" << _end2 << endl;
        }
        else {
        _beg =  _thieft_beg1;
        _beg2 = _thieft_beg2; 
        _end = nextj->get_end();
        _end2 = nextj->get_end2();
            //cout << "prempt : beg1=" <<  _beg << ", _end=" << _end << endl;
            //cout << "preempt : beg2=" <<  _beg2 << ", _end2=" << _end2 << endl;
        }
        
        if((_beg < _end) || (_beg2 < _end2)) {
           /*cout << "Jump Intervall to complete 1 :[" << _beg << " " << _end << "[" << endl;
           cout << "Jump Intervall to complete 2 :[" << _beg2 << " " << _end2 << "[" << endl;
           cout << "jump :  _sz = " << _sz << endl;
           cout << "diff1=" << nextj->get_beg()- _beg << endl;
           cout << "diff2=" << nextj->get_beg2()- _beg2 << endl;*/
        }
   }


};


template <class T,  class Compare>
void adapt_merge(T* first, T* last, T* first2, T* last2, T* output, Compare cmp,
             int seqgrain=10, int pargrain=2)
{
     MergeWork<T, Compare>* work = new  MergeWork<T, Compare>(first, last, first2, last2, output, 0, 0, cmp, seqgrain);
    adapt::run_adapt(work);
}


template <class T>
void adapt_merge(T* first, T* last, T* first2, T* last2, T* output,
      int seqgrain=10, int pargrain=2) 
{
    adapt_merge( first, last, first2,  last2, output, std::less<T>(), seqgrain, pargrain);    
}

#endif
