
#include <iostream>
#include <numa.h>
#include <numeric>
#include "tbb/task_scheduler_init.h"
#include "tbb/tick_count.h"

#include "prod_iter.h"

typedef double val_t ;


int main(int argc, char ** argv) {
      
	    
      int size = (argc > 1)?atoi(argv[1]):100000000;
      int nthread = (argc > 2)?atoi(argv[2]):1;
      int c = (argc > 3)?atoi(argv[3]):100;


       val_t *data = (val_t*) numa_alloc_interleaved(size*sizeof(val_t));
       std::cout << "size =" << size << std::endl;
       for(int i =0; i < size; i++) data[i] = i+1;
 
       tbb::task_scheduler_init init(nthread);

       tbb::tick_count t0, t1;
       std::cout << "***********Start of computation**********" << std::endl;
       t0 = tbb::tick_count::now();
         val_t res = adapt_accumulate(data, data+size, c) ;
       t1 = tbb::tick_count::now();

       std::cout << "-----------------------------------" << std::endl;
       printf (": time = %.6f s\n", (t1-t0).seconds());
       std::cout << ": res = " << res << std::endl;
       std::cout << std::endl;
       std::cout << "-----------------------------------" << std::endl;

       
       val_t res_stl = std::accumulate(data, data+size, 0.0); //STL
       std::cout << "res_stl = " << res_stl << std::endl;
       if(res_stl-res < 1e-6)
              std::cout << "Le calcul est correct  " << std::endl;
       else std::cout << "Le calcul n'est pas correct  " << std::endl;
 
       numa_free(data, size*sizeof(val_t));    
  return 0;
};

