#ifndef _ATHA_Prod_iter_H_
#define _ATHA_Prod_iter_H_

#include <numeric>
#include "../tbb_adapt.h"

class MyNextJump : public adapt::NextJump {

     int _beg;
     int _end;
   public :
     MyNextJump(int beg=0, int end=0): NextJump(), _beg(beg), _end(end) { }
     void init(int beg, int end) { _beg = beg; _end = end; }
     int get_end() const { return _end;}
     void set_end(int end){ _end = end;}
     int  get_beg() const { return _beg;}
     void set_beg(int beg) {  _beg = beg;}
     bool is_empty() const { return _end <= _beg; }
    // void init_work() const { cout << "MyNextjump" << endl; }
};
 
template<class T>
class ProditerWork : public adapt::WorkAdapt
{
     T* _first;
     T* _last;
     T _local_res;
    int _beg;
    int _end;
    const int _init_beg;
    const int _init_end;
    int _seqgrain;
    int _pargrain;
    int _c;
    int _beg_local;
    int _end_local;
    int _work_do_size;
    public:

     ProditerWork(T* first, T* last, int beg, int c =1, int pargrain=2): 
       WorkAdapt(), _first(first),  _last(last), _local_res(T(0)),
         _beg(beg), _init_beg(_beg), _init_end(last - first), _pargrain(pargrain), _c(c)
    {
            _end = _init_end;
           if(c <=0) _seqgrain = 1;
           else _seqgrain = _c * adapt::log_2(_end);
    }


    bool extract_nextseq()
    {
        
        if( _beg < _end ) {
            _beg_local = _beg; _beg +=_seqgrain;
            if( _beg > _end)  _beg = _end;
            _end_local = _beg;
           return true;
         } 
       return false;

    }


    bool extract_par( WorkAdapt*& sw)
    {
           if((_end - _beg) > _pargrain) {
             int i, j;
             int mid = _end - ((_end - _beg)/2);

             
             i = mid;
             j = _end;
             _end = mid;
             //cout << "work : (i, j)=" << "("<< _beg << ", " << _end << ")" << endl;
             //cout << "stolen work : (i, j)=" << "("<< i << ", " << j << ")" << endl;
             sw = new  ProditerWork<T>(_first, _first+j, i, _c);
            return true;
           }
           else {
            sw = new  ProditerWork<T>(_first, _first, 0, 0);
           return false;
          }
    }

    void join(const WorkAdapt* jw)
    {
        const  ProditerWork * src = dynamic_cast< const  ProditerWork*> ( jw ); 
    
          T thief_res = src->get_result();
           //std::cout << "victim_res =" << _local_res << std::endl;
           //std::cout << "thief_res =" << thief_res << std::endl;
          _local_res +=thief_res ; 
    }

    void  localcompute()
    { 
       //Util::Thread::sleep(1000, 1); 
      _local_res = std::accumulate(_first + _beg_local, _first + _end_local, _local_res) ;
    }

    inline bool  MustJump() const { return true; }

    T get_result() const
    {
        return _local_res ;
    }

    void setjump(adapt::NextJump*& j) {
        
          int end = _end;
          _end = _beg;

          j = new MyNextJump(_beg, end);   
                
   }

   void jump(const adapt::NextJump* j) {
        
        const  MyNextJump * nextj = dynamic_cast< const  MyNextJump*> ( j );
        _beg = nextj->get_beg();
        _end = nextj->get_end();
       /* if(_beg < _end) {
          cout << "Jump Intervall to complete :[" << _beg << " " << _end << "[" << endl;
       }*/
   }

};

template <class T>
T adapt_accumulate(T* first, T* last,
      int seqgrain=10, int pargrain=2) 
{
    /* init remote iterator */
     ProditerWork<T>* work = new  ProditerWork<T>(first, last, 0, seqgrain);
    adapt::run_adapt(work);
    T res = work->get_result();
    return res ; 
}

#endif
