#ifndef _ATHA_Prod_iter_H_
#define _ATHA_Prod_iter_H_

#include <numeric>
#include <cmath>
#include "../cilk_adapt.h"

template<class T>
struct my_fct {
    my_fct(){ };
    T operator()(T a){
         //return  2*a;
      return std::sin(a);
    }
};

template<class T>
bool verif (T first, T last, T res) {
     int i = 0;
     int cpt = 0;
     bool is_ok = true;
     if(*first!=*res) {
      std::cerr << "Erreur: res[" << i << "]=" << *res << "!=" << *first << std::endl;
      is_ok=false;
     }
     while(++first!=last) {
       ++res;
       i++;
       if(*first!=*res) {
        cpt++;
        if(cpt < 10)  std::cerr << "Erreur: res[" << i << "]=" << *res << "!=" << *first << std::endl;
        is_ok=false;
      }
     }
 return is_ok;
}


class MyNextJump : public adapt::NextJump {

     int _beg;
     int _end;
   public :
     MyNextJump(int beg=0, int end=0): NextJump(), _beg(beg), _end(end) { }
     void init(int beg, int end) { _beg = beg; _end = end; }
     int get_end() const { return _end;}
     void set_end(int end){ _end = end;}
     int  get_beg() const { return _beg;}
     void set_beg(int beg) {  _beg = beg;}
     bool is_empty() const { return _end <= _beg; }
    // void init_work() const { cout << "MyNextjump" << endl; }
};
 
template<class T>
class TransformWork : public adapt::WorkAdapt
{
     T* _first;
     T* _last;
     T* _res;
     T _local_res;
    int _beg;
    int _end;
    const int _init_beg;
    const int _init_end;
    int _seqgrain;
    int _pargrain;
    int _c;
    int _beg_local;
    int _end_local;
    int _work_do_size;
    public:

     TransformWork(T* first, T* last, T* res, int beg, int c =1, int pargrain=2): 
       WorkAdapt(), _first(first),  _last(last), _res(res), _local_res(T(0)),
         _beg(beg), _init_beg(_beg), _init_end(last - first), _pargrain(pargrain), _c(c)
    {
            _end = _init_end;
           if(c <=0) _seqgrain = 1;
           else _seqgrain = _c * adapt::log_2(_end);
    }


    bool extract_nextseq()
    {
        
        if( _beg < _end ) {
            _beg_local = _beg; _beg +=_seqgrain;
            if( _beg > _end)  _beg = _end;
            _end_local = _beg;
           return true;
         } 
       return false;

    }


    bool extract_par( WorkAdapt*& sw)
    {
           if((_end - _beg) > _pargrain) {
             int i, j;
             int mid = _end - ((_end - _beg)/2);

             
             i = mid;
             j = _end;
             _end = mid;
             std::cout << "work : (i, j)=" << "("<< _beg << ", " << _end << ")" << std::endl;
             std::cout << "stolen work : (i, j)=" << "("<< i << ", " << j << ")" << std::endl;
             sw = new  TransformWork<T>(_first, _first+j, _res, i, _c);
            return true;
           }
           else {
            sw = new  TransformWork<T>(_first, _first, _res, 0, 0);
           return false;
          }
    }

    void  localcompute()
    { 
       //Util::Thread::sleep(1000, 1); 
       std::transform(_first + _beg_local, _first + _end_local, _res+_beg_local, my_fct<T>()) ;
    }

    bool is_empty() {
      return _beg >= _end;
    }

    //inline bool  MustJump() const { return true; }

    inline bool  MainJump() const { return false;}

    void setjump(adapt::NextJump*& j) {
        
          int end = _end;
          _end = _beg;

          j = new MyNextJump(_beg, end);   
                
   }

   void jump(const adapt::NextJump* j) {
        
        const  MyNextJump * nextj = dynamic_cast< const  MyNextJump*> ( j );
        _beg = nextj->get_beg();
        _end = nextj->get_end();
       /* if(_beg < _end) {
          cout << "Jump Intervall to complete :[" << _beg << " " << _end << "[" << endl;
       }*/
   }

};

template <class T>
void adapt_transform(T* first, T* last, T*res,
      int seqgrain=10, int pargrain=2) 
{
    TransformWork<T>* work = new  TransformWork<T>(first, last, res, 0, seqgrain);
    adapt::run_adapt(work);
}

#endif
